<template>
	<f7-page 
        name="inventory" 
        @page:beforein="onPageBeforeIn"
        @page:beforeout="onPageBeforeOut"
        ptr 
        @ptr:refresh="onPageRefresh"
        infinite
        :infinite-distance="50"
        :infinite-preloader="showPreloader"
        @infinite="loadMore">
		<!-- Top Navbar -->
		<f7-navbar :sliding="false" large title-large="Inventaris">
			<f7-nav-left back-link>
            </f7-nav-left>
            <f7-nav-title class="show-small-title">{{ currentCategory }}</f7-nav-title>
            <f7-nav-right>
                <f7-link href="/inventory/create/" icon-f7="add" color="smoothgray" icon-only></f7-link>
            </f7-nav-right>
		</f7-navbar>

        <!-- Page Content -->
        <f7-block-title v-if="!movementLoading && movements.length > 0" class="swiper-title menu-grid-title">Pergerakan Barang Inventaris</f7-block-title>
		<f7-block v-if="movements.length > 0">			
			<f7-swiper class="card-swipe inventories-card-swipe" :params="{loop: movements.length > 1, speed:900, slidesPerView:1, spaceBetween: 20, centeredSlides:true}">
				<f7-swiper-slide v-for="item in movements" v-bind:key="item.id">
					<f7-card @cardBeforeOpen="hideTitle" @cardClose="showTitle" @cardOpened="setSwipeOff" @cardClosed="setSwipeOn" expandable style="height:200px;">
						<f7-card-content :padding="false" class="first">
							<div :class="bgColors.random()" :style="{height: '200px'}">
								<f7-card-header text-color="white" class="display-block">
									<span class="card-header-title">{{ item.inventory.title }}</span>
									<br />  
                                    <small v-if="item.signs.length > 0" class="card-datetime display-block">{{ statusText(item.status) }}</small>                                  
									<small v-if="item.signs.length == 0" class="card-datetime display-block">Dalam Proses Pengajuan</small>                                    
                                    <small class="card-datetime display-block no-margin">Oleh: {{ item.name }}</small>
                                    <small class="card-datetime display-block no-margin">{{ dateFormat(item.start_date, 'DD/MM/YYYY') }} - {{ dateFormat(item.end_date, 'DD/MM/YYYY') }}</small>
                                    <small v-if="item.signs.length == 0" class="card-datetime display-block no-margin">(Belum Disetujui)</small>
								</f7-card-header>
								<f7-link card-close color="white" class="card-opened-fade-in" :style="{position: 'absolute', right: '15px', top: '15px'}" icon-f7="close_round"></f7-link>
							</div>
							<div class="card-content-padding">
								
                                <br>
								<ul style="list-style:none;padding-left:0;">
									<li>
										<strong style="display:block;width:100px;margin-right:10px;float:left">No</strong>: {{ item.number }}
									</li>
									<li>
										<strong style="display:block;width:100px;margin-right:10px;float:left">Perihal</strong>: {{ aboutStatusText(item.status) }}
									</li>                                    
								</ul>
                                <br>
								<p>Kepada Yth. <br>Ketua Perumahan {{ item.residential.name }}<br>{{ item.residential.address }}, {{ item.residential.administrative_region[0] }}, {{ item.residential.administrative_region[1] }}, <br>{{ item.residential.administrative_region[2] }}, {{ item.residential.administrative_region[3] }}, {{ item.residential.administrative_region[4] }}</p>
								<br>
                                <p>Dengan ini saya,</p>
                                <table>
                                    <tr>
                                        <td width="100" valign="top" style="padding:5px 0;"><strong>Nama</strong></td>
                                        <td width="10" valign="top" style="padding:5px 0;">:</td>
                                        <td valign="top" style="padding:5px 0;">{{ item.name }}</td>
                                    </tr>
                                    <tr>
                                        <td width="100" valign="top" style="padding:5px 0;"><strong>Alamat</strong></td>
                                        <td width="10" valign="top" style="padding:5px 0;">:</td>
                                        <td valign="top" style="padding:5px 0;">{{ item.address }}, {{ item.residential.administrative_region.join(", ") }}</td>
                                    </tr>
                                    <tr>
                                        <td width="100" valign="top" style="padding:5px 0;"><strong>No. HP</strong></td>
                                        <td width="10" valign="top" style="padding:5px 0;">:</td>
                                        <td valign="top" style="padding:5px 0;">{{ item.phone }}</td>
                                    </tr>
                                </table>
                                <p>Bermaksud mengajukan <strong>{{ aboutStatusText(item.status) }}</strong> berupa <strong>{{ item.quantity }} unit {{ item.inventory.title }}</strong> dari tanggal <strong>{{ dateFormat(item.start_date, 'DD-MM-YYYY') }}</strong> sampai <strong>{{ dateFormat(item.start_date, 'DD-MM-YYYY') }}</strong> <span v-if="item.cost > 0"> dengan biaya sebesar Rp {{ item.cost.format(2,0,',','.') }}</span>.</p>
                                <p v-if="item.description">*{{ item.description }}</p>
                                <br>
                                <br>
                                <strong v-if="item.signs.length > 0" class="display-block">{{ item.administrative_region[2].replace(/(Kota|Kab)/g, '')+', '+dateFormat(item.updated, 'DD MMMM YYYY') }}</strong>
                                <br>                                
                                <f7-row class="payer text-align-left" v-if="item.signs.length > 0">
                                    <f7-col v-for="(sign, index) in item.signs" v-bind:key="sign.id">
                                        <strong v-if="index == 0" class="display-block">Disetujui Oleh:</strong>
                                        <br v-if="index == 0">
                                        <span class="display-block">{{ sign.position }}</span>
                                        <strong class="display-block">{{ sign.name }}</strong>
                                    </f7-col>
                                </f7-row>
                                <br>
                                <br>
                                <small v-if="item.signs.length > 0" class="text-align-left display-block no-margin">Tanda terima ini merupakan bukti yang sah antar kedua belah pihak.</small>
							</div>
						</f7-card-content>
					</f7-card>
				</f7-swiper-slide>
				
			</f7-swiper>
		</f7-block>
		<f7-card
			v-if="user.role.slug != 'public' && movementLoading"
			class="skeleton-text"
			title="Card Header"
			content="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit."
			footer="Card Footer"
		></f7-card>

        <f7-block-title v-if="inventories.length > 0" class="swiper-title menu-grid-title">Barang Inventaris</f7-block-title>
        <f7-block v-if="inventoryCategories.length > 0">
			<f7-toolbar tabbar scrollable position="top" no-shadow no-hairlines class="no-background" style="top:0;">
                <f7-link @click="handleInventoryCategory('semua')" :class="`gradient-box${slugify(currentCategory) == 'semua' ? ' tab-link-active' : ''}`">
					<span class="">Semua</span>									
				</f7-link>
				<f7-link @click="handleInventoryCategory(item.slug)" :class="`gradient-box${slugify(currentCategory) == item.slug ? ' tab-link-active' : ''}`" v-for="(item, index) in inventoryCategories" :key="index">
					<span class="">{{ item.name }}</span>									
				</f7-link>
			</f7-toolbar>
		</f7-block>

        <f7-list media-list no-hairlines v-if="!inventoryLoading && inventories.length > 0">
            <f7-list-item
                v-for="(item, index) in inventories"
                :key="index"
                :link="`/inventory/view/${item.id}/`"
                :after="hoursAgo(item.created)"
                :title="item.category.name"
                :subtitle="item.title"
                :text="item.number"
            >
                <img slot="media" v-if="item.medias.length > 0" :src="item.medias[0].url.medium" width="48" class="img-circle"/>
                <img slot="media" v-else :src="require('../assets/no-photo.jpg')" width="48" class="img-circle"/>
            </f7-list-item>
            
        </f7-list>
        <f7-block v-else-if="!inventoryLoading" style="height: calc(100% - 100px)">
			<span class="display-flex align-items-center justify-content-center" style="height:calc(100% - 100px);">
				<span class="text-align-center">
					<span class="display-block text-align-center">
						<f7-icon material="grid_off" style="font-size:100px;color:#eee;"></f7-icon>
						<span class="display-block">It's a little quiet here</span>
					</span>
				</span>
			</span>
		</f7-block>
        <f7-list media-list no-hairlines v-if="inventoryLoading">
            <f7-list-item
                v-for="n in 4"
                :key="n"
                class="skeleton-text skeleton-effect-blink"
                title="Full Name"
                subtitle="Position"
                after="31 Juli 2019"
                text="Lorem ipsum dolor sit amet, consectetur adipiscing elit. Morbi lobortis et massa ac interdum. Cras consequat felis at consequat hendrerit. Aliquam vestibulum vitae lorem ac iaculis. Praesent nec pharetra massa, at blandit lectus. Sed tincidunt, lectus eu convallis elementum, nibh nisi aliquet urna, nec imperdiet felis sapien at enim."
            >
                <f7-skeleton-block style="width: 48px; height: 48px; border-radius: 50%" slot="media"></f7-skeleton-block>
            </f7-list-item>
        </f7-list>
    </f7-page>
</template>
<script>
import moment from 'moment';
import { mapGetters } from 'vuex';
import { dateFormat, slugify, hoursAgo } from '../js/utils';
import { setTimeout } from 'timers';
export default {
    name: 'Inventory',
    data(){
        return{
            movementLoading: true,
            inventoryLoading: true,
            showPreloader: true,
            allowInfinite: true,
            currentCategory: 'Semua',
            currentCategoryId: null
        }
    },
    computed: {
        ...mapGetters(['bgColors']),
        ...mapGetters('auth', ['user']),
        ...mapGetters('category', ['inventoryCategories']),
        ...mapGetters('residential', ['residentials']),
        ...mapGetters('inventory', [
            'inventories', 
            'pagination'
        ]),
        ...mapGetters('movement', ['movements'])
    },
    methods: {
        dateFormat,
        hoursAgo,
        slugify,
        statusText(status){
            if(status == 'waiting'){
                return 'Menunggu Persetujuan'
            }else if(status == 'onloan'){
                return 'Sedang Dipinjam';
            }else if(status == 'missing'){
                return 'Hilang';
            }else if(status == 'rentedout'){
                return 'Sedang Disewa';
            }else if(status == 'beingrepaired'){
                return 'Sedang Diperbaiki';
            }else if(status == 'broken'){
                return 'Rusak';
            }else if(status == 'fixed'){
                return 'Telah Diperbaiki';
            }
        },
        aboutStatusText(status){
            if(status == 'waiting'){
                return 'Permohonan Pinjam/Sewa Barang'
            }else if(status == 'onloan'){
                return 'Permohonan Pinjam Barang';
            }else if(status == 'rentedout'){
                return 'Permohonan Sewa Barang';
            }else if(status == 'beingrepaired'){
                return 'Permohonan Perbaikan Barang';
            }else if(status == 'broken'){
                return 'Rusak';
            }
        },
        getCategories(){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('category/getCategories', {
                module: 'inventory', 
                page: 1,
                perpage: 100,
                only: 'id,name,slug'
            });
        },
        getInventories(page, loadmore){
            const self = this;
            const app = self.$f7;

            self.$store.dispatch('inventory/getInventories', {
                page: page,
                perpage: 25,
                loadmore: loadmore,
                category: self.currentCategoryId,
                only: 'id,number,title,quantity,received_date,residential.name,residential.administrative_region,residential.address,created,updated,medias.id,medias.mimetype,medias.original_filename,medias.filename,medias.url,author.id,author.profile.fullname,author.profile.initial,author.profile.media,category.id,category.name'
            }).then((response) => {
                setTimeout(() => {
                    self.showPreloader = self.pagination.has_next;
                    self.inventoryLoading = false;
                }, 100);
            });
        },
        getMovements(){
            const self = this;
            const app = self.$f7;

            let today = moment().format('YYYY-MM-DD');

            self.$store.dispatch('movement/getMovements', {
                duration: [null, today],
                only: 'id,name,number,address,phone,quantity,cost,start_date,end_date,created,updated,description,phone,signs.id,signs.name,signs.position,status,inventory.id,inventory.title,inventory.category.id,inventory.category.name,residential.id,residential.name,residential.address,residential.administrative_region,administrative_region'
            }).then(()=>{
                setTimeout(() => {
                    self.movementLoading = false;
                }, 100);
            });
        },
        onPageBeforeIn(){
            const self = this;

            self.getCategories();
            self.getInventories(1, false);
            self.getMovements();
        },
        onPageBeforeOut(page){
            const self = this;

            if(page.detail.name == 'inventory'){
                self.currentCategory = 'Semua';
                self.currentCategoryId = null;
                self.$store.dispatch('category/resetCategories', {
                    module: 'inventory'
                });
                self.$store.dispatch('inventory/resetInventories');
            }
        },
        onPageRefresh(e, done){
            const self = this;

            self.$store.dispatch('category/resetCategories', {
                module: 'inventory'
            }).then(()=>{
                self.movementLoading = true;
                self.inventoryLoading = true;
                self.getCategories();
            });

            self.getInventories(1, false);
            self.getMovements();
            done();
        },
        hideTitle(){
			const self = this;
			self.$$('.swiper-title').hide();
		},
		showTitle(){
			const self = this;
			self.$$('.swiper-title').show();
		},
		setSwipeOff() {
			const self = this;
			var mySwiper = self.$f7.swiper.get('.inventories-card-swipe');
			
			setTimeout(() =>{
				mySwiper.detachEvents();
			},100);
		},
		setSwipeOn() {
			const self = this;
			var mySwiper = self.$f7.swiper.get('.inventories-card-swipe');			
			setTimeout(() =>{
				mySwiper.attachEvents();				
			},100);
        },
        loadMore() {
            const self = this;

            if (!self.allowInfinite) return;
            self.allowInfinite = false;

            setTimeout(()=>{
                if(self.pagination.has_next){
                    self.getInventories(self.pagination.page + 1, true);
                    self.allowInfinite = true;                 
                }else{
                    self.showPreloader = false;
                }
            }, 1000);
        },
        handleInventoryCategory(category){
			const self = this;
            const app = self.$f7;
            
            self.inventoryLoading = true;
            
            if(category != 'semua'){                
                for(const x of self.inventoryCategories){
                    if(x.slug == category){
                        self.currentCategory = x.name;
                        self.currentCategoryId = x.id;
                        break;
                    }
                }
            }else{
                self.currentCategoryId = null;
                self.currentCategory = 'Semua';
            }

            self.$store.dispatch('inventory/resetInventories').then(()=>{
                self.getInventories(1, false);
            });
		}
    }
}
</script>
